## opencl-clang-19 19.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

if(NOT DEFINED BASE_LLVM_VERSION)
  set(BASE_LLVM_VERSION 19.1)
endif(NOT DEFINED BASE_LLVM_VERSION)
set(OPENCL_CLANG_VERSION ${BASE_LLVM_VERSION}.0)

if(NOT DEFINED OPENCL_CLANG_BUILD_EXTERNAL)
  # check if we build inside llvm or not
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(OPENCL_CLANG_BUILD_EXTERNAL YES)
  endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
endif(NOT DEFINED OPENCL_CLANG_BUILD_EXTERNAL)

if(OPENCL_CLANG_BUILD_EXTERNAL)
  project(OPENCL_CLANG
    LANGUAGES
      CXX
      C
  )
endif()

# Do not omit TARGET_OBJECTS expression from the SOURCES target
# property
# `cmake --help-policy CMP0051` for details.
cmake_policy(SET CMP0051 NEW)
cmake_policy(SET CMP0057 NEW)
cmake_policy(SET CMP0022 NEW)

set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

include(CMakeFunctions)

if(CMAKE_CROSSCOMPILING AND OPENCL_CLANG_BUILD_EXTERNAL)
  include(CrossCompile)
  llvm_create_cross_target(${PROJECT_NAME} NATIVE "" Release)
endif()

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(USE_PREBUILT_LLVM ON)

    add_definitions(-DUSE_PREBUILT_LLVM)

    if(NOT PREFERRED_LLVM_VERSION)
        set(PREFERRED_LLVM_VERSION "19.1")
    endif(NOT PREFERRED_LLVM_VERSION)
    message(STATUS "[OPENCL-CLANG] Looking for LLVM version ${PREFERRED_LLVM_VERSION}")
    find_package(LLVM ${PREFERRED_LLVM_VERSION} REQUIRED)

    message(STATUS "[OPENCL-CLANG] Using LLVMConfig.cmake in: ${LLVM_DIR}")
    message(STATUS "[OPENCL-CLANG] Found LLVM ${LLVM_PACKAGE_VERSION}")

    set(CMAKE_MODULE_PATH
      ${CMAKE_MODULE_PATH}
      ${LLVM_CMAKE_DIR})

    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)

    option(LLVMSPIRV_INCLUDED_IN_LLVM
      "Set to ON if libLLVMSPIRVLib is linked into libLLVM" ON)
    if(LLVMSPIRV_INCLUDED_IN_LLVM)
        message(STATUS "[OPENCL-CLANG] Assuming that libLLVMSPIRVLib is linked into libLLVM")
    else(LLVMSPIRV_INCLUDED_IN_LLVM)
        message(STATUS
          "[OPENCL-CLANG] Assuming that libLLVMSPIRVLib is NOT linked into libLLVM")
        if(NOT SPIRV_TRANSLATOR_DIR)
            message(FATAL_ERROR "[OPENCL-CLANG] SPIRV_TRANSLATOR_DIR is required")
        endif(NOT SPIRV_TRANSLATOR_DIR)
    endif(LLVMSPIRV_INCLUDED_IN_LLVM)
else(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(USE_PREBUILT_LLVM OFF)
    find_package(Git REQUIRED)
endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)

include(AddLLVM)
include(TableGen)

if (NOT WIN32)
    add_subdirectory( linux_linker bin)
endif()

use_rtti(FALSE)
use_eh(TRUE)

if (CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(ADDR 32)
elseif (CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(ADDR 64)
else ()
  # CMAKE_SIZEOF_VOID_P might not be set on windows x86 in in-tree build
  message(WARNING "[OPENCL-CLANG] CMAKE_SIZEOF_VOID_P is not set")
  if (WIN32 AND LLVM_BUILD_32_BITS)
    set(ADDR 32)
  endif()
endif (CMAKE_SIZEOF_VOID_P EQUAL 4)

# set windows binary suffix
if (WIN32)
    set (BUILD_PLATFORM ${ADDR})
else (WIN32)
    set (BUILD_PLATFORM "")
endif (WIN32)

# set that name of the main output file as a target name
if (NOT DEFINED OPENCL_CLANG_LIBRARY_NAME)
    set(OPENCL_CLANG_LIBRARY_NAME "opencl-clang")
endif()
set(TARGET_NAME ${OPENCL_CLANG_LIBRARY_NAME}${BUILD_PLATFORM} )

# OPENCL_CLANG_PCH_EXTENSION can override PCH extension map in options_compile.cpp.
# Example: "cl_khr_3d_image_writes,cl_khr_depth_images"
set(OPENCL_CLANG_PCH_EXTENSION "" CACHE STRING "Comma-separated list of OpenCL extensions")
if (NOT "${OPENCL_CLANG_PCH_EXTENSION}" STREQUAL "")
  add_definitions(-DPCH_EXTENSION="${OPENCL_CLANG_PCH_EXTENSION}")
endif()

if(NOT USE_PREBUILT_LLVM)

    if(NOT LLVM_EXTERNAL_CLANG_SOURCE_DIR)
        set(CLANG_SOURCE_DIR ${LLVM_SOURCE_DIR}/tools/clang)
    elseif(EXISTS "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}/CMakeLists.txt")
        set(CLANG_SOURCE_DIR "${LLVM_EXTERNAL_CLANG_SOURCE_DIR}")
    endif()
    if(EXISTS ${CLANG_SOURCE_DIR})
        message(STATUS "[OPENCL-CLANG] Using Clang source code direcotry: ${CLANG_SOURCE_DIR}")
    else()
        message(FATAL_ERROR
            "[OPENCL-CLANG] Can't find Clang source code directory!\n"
            "If you are using LLVM monorepo:\n"
            "  1. Clean CMake cache: `rm CMakeCache.txt`\n"
            "  2. Enable Clang project with `-DLLVM_ENABLE_PROJECTS=\"clang\"` option\n"
            "If Clang is used as a separate repository (not monorepo), it should "
            "be checked out at `llvm/tools/clang`."
        )
    endif()

    if(NOT LLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR)
        set(SPIRV_SOURCE_DIR ${LLVM_SOURCE_DIR}/projects/llvm-spirv)
    elseif(EXISTS "${LLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR}/CMakeLists.txt")
        set(SPIRV_SOURCE_DIR ${LLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR})
    endif()
    if(EXISTS ${SPIRV_SOURCE_DIR})
        message(STATUS "[OPENCL-CLANG] Using SPIRV-LLVM-Translator source code directory: ${SPIRV_SOURCE_DIR}")
    else()
        message(FATAL_ERROR
            "[OPENCL-CLANG] Can't find SPIRV-LLVM-Translator source code dir!\n"
            "If you are using LLVM monorepo, SPIRV-LLVM-Translator should be checked out "
            "at '<monorepo_root_dir>/llvm-spirv' and it should be enabled as an external LLVM "
            "project using the following 2 options:\n"
            "  -DLLVM_EXTERNAL_PROJECTS=\"opencl-clang;llvm-spirv\"\n"
            "  -DLLVM_EXTERNAL_LLVM_SPIRV_SOURCE_DIR=\"<monorepo_root_dir>/llvm-spirv\"\n"
            "If you are not using LLVM monorepo, SPIRV-LLVM-Translator should be checked "
            "out at `llvm/projects/llvm-spirv`"
        )
    endif()

    set(CLANG_BASE_REVISION release/19.x)
    set(SPIRV_BASE_REVISION llvm_release_190)
    set(TARGET_BRANCH "ocl-open-190")

    apply_patches(${CLANG_SOURCE_DIR}
                  ${CMAKE_CURRENT_SOURCE_DIR}/patches/clang
                  ${CLANG_BASE_REVISION}
                  ${TARGET_BRANCH})
    apply_patches(${SPIRV_SOURCE_DIR}
                  ${CMAKE_CURRENT_SOURCE_DIR}/patches/spirv
                  ${SPIRV_BASE_REVISION}
                  ${TARGET_BRANCH})
endif(NOT USE_PREBUILT_LLVM)

#
# TblGen the options include file
#
set (COMPILE_OPTIONS_TD  opencl_clang_options.td)
set (COMPILE_OPTIONS_INC opencl_clang_options.inc)

find_program(LLVM_TABLEGEN_EXE "llvm-tblgen" ${LLVM_TOOLS_BINARY_DIR})
set(LLVM_TARGET_DEFINITIONS ${COMPILE_OPTIONS_TD})
if(USE_PREBUILT_LLVM)
  set(TABLEGEN_ADDITIONAL -I ${LLVM_INCLUDE_DIRS})
else(USE_PREBUILT_LLVM)
  set(TABLEGEN_ADDITIONAL "")
endif(USE_PREBUILT_LLVM)
tablegen(LLVM ${COMPILE_OPTIONS_INC} -gen-opt-parser-defs ${TABLEGEN_ADDITIONAL})
add_public_tablegen_target(CClangCompileOptions)

#
# Source code
#
set(TARGET_INCLUDE_FILES
    opencl_clang.h
    options.h
    binary_result.h
    pch_mgr.h
    ${COMPILE_OPTIONS_TD}
    ${COMPILE_OPTIONS_INC}
)

set(TARGET_SOURCE_FILES
    opencl_clang.cpp
    options.cpp
    pch_mgr.cpp
    options_compile.cpp
)

#
# Resources
#

set( PRODUCT_VER_MAJOR 2 )
set( PRODUCT_VER_MINOR 0 )
set (LLVM_VER_MAJOR ${LLVM_VERSION_MAJOR} )
set (LLVM_VER_MINOR ${LLVM_VERSION_MINOR} )

add_definitions( -D__STDC_LIMIT_MACROS )
add_definitions( -D__STDC_CONSTANT_MACROS )
add_definitions( -DOPENCL_CLANG_EXPORTS )

#
# Include directories
#

if(NOT USE_PREBUILT_LLVM)
    set(CLANG_BINARY_DIR ${LLVM_BINARY_DIR}/tools/clang/)
    include_directories(
        ${CLANG_BINARY_DIR}/include  # for tablegened includes
        ${CLANG_SOURCE_DIR}/include  # for basic headers
        ${SPIRV_SOURCE_DIR}/include) # for SPIRV headers
endif(NOT USE_PREBUILT_LLVM)

if(USE_PREBUILT_LLVM AND NOT LLVMSPIRV_INCLUDED_IN_LLVM)
    include_directories(${SPIRV_TRANSLATOR_DIR}/include)
    link_directories(${SPIRV_TRANSLATOR_DIR}/lib${LLVM_LIBDIR_SUFFIX})
endif(USE_PREBUILT_LLVM AND NOT LLVMSPIRV_INCLUDED_IN_LLVM)

include_directories( AFTER
            ${LLVM_INCLUDE_DIRS}
            ${CMAKE_CURRENT_BINARY_DIR}
            ${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_CFG_INTDIR}
            )

link_directories(
    ${LLVM_LIBRARY_DIRS}
)

set(OPENCL_CLANG_LINK_LIBS ${CMAKE_DL_LIBS})

if(NOT LLVMSPIRVLib IN_LIST LLVM_AVAILABLE_LIBS OR (USE_PREBUILT_LLVM AND LLVM_LINK_LLVM_DYLIB))
  # SPIRV-LLVM-Translator is not included into LLVM as a component.
  # So, we need to list it here explicitly as an external library
  list(APPEND OPENCL_CLANG_LINK_LIBS LLVMSPIRVLib)
endif()

add_subdirectory(cl_headers)

set(LLVM_REQUIRES_EH ON)

if(USE_PREBUILT_LLVM OR CLANG_LINK_CLANG_DYLIB)
  list(APPEND OPENCL_CLANG_LINK_LIBS clang-cpp)
else()
  list(APPEND OPENCL_CLANG_LINK_LIBS
    clangBasic
    clangFrontend
    clangFrontendTool
    clangSerialization
  )
endif()

if(USE_PREBUILT_LLVM AND UNIX)
  # llvm_map_components_to_libnames(... all) returns empty string if llvm is
  # pre-built locally in either static or shared type in Ubuntu 22.04 container.
  find_program(LLVM_CONFIG_EXE
    NAMES llvm-config-${PREFERRED_LLVM_VERSION} llvm-config
    PATHS ${LLVM_BINARY_DIR} ${LLVM_BINARY_DIR}/bin)
  if(NOT LLVM_CONFIG_EXE)
    message(FATAL_ERROR "[OPENCL-CLANG] llvm-config is not found")
  endif()

  execute_process(COMMAND ${LLVM_CONFIG_EXE} --libs all OUTPUT_VARIABLE ALL_LIBS)
  string(REGEX REPLACE "( |\r|\n|-l)+" ";" ALL_LLVM_LIBS ${ALL_LIBS})
  set(ALL_LLVM_LIBS "LLVMSPIRVLib${ALL_LLVM_LIBS}")
else()
  llvm_map_components_to_libnames(ALL_LLVM_LIBS all)
endif()
set(OPENCL_CLANG_EXCLUDE_LIBS_FROM_ALL "" CACHE STRING "Space-separated list of LLVM libraries to exclude from all")
if (NOT "${OPENCL_CLANG_EXCLUDE_LIBS_FROM_ALL}" STREQUAL "")
  list(REMOVE_ITEM ALL_LLVM_LIBS ${OPENCL_CLANG_EXCLUDE_LIBS_FROM_ALL})
endif()
list(APPEND OPENCL_CLANG_LINK_LIBS ${ALL_LLVM_LIBS})

add_llvm_library(${TARGET_NAME} SHARED
  ${TARGET_INCLUDE_FILES}
  ${TARGET_SOURCE_FILES}
  $<TARGET_OBJECTS:cl_headers>

  DEPENDS CClangCompileOptions

  LINK_LIBS
    ${OPENCL_CLANG_LINK_LIBS}
  )

if (WIN32)
    # Enable compiler generation of Control Flow Guard security checks.
    target_compile_options(${TARGET_NAME} PUBLIC "/guard:cf")
    set_property(TARGET ${TARGET_NAME} APPEND_STRING PROPERTY
        LINK_FLAGS "/DYNAMICBASE /GUARD:CF")

elseif(UNIX)
    set_property(TARGET ${TARGET_NAME} APPEND_STRING PROPERTY
        COMPILE_DEFINITIONS LIBOPENCL_CLANG_NAME="$<TARGET_SONAME_FILE_NAME:${TARGET_NAME}>")
    
    # Sanitizers do not support this flag, disable this when under sanitizer build
    if(NOT LLVM_USE_SANITIZER)
        set_property(TARGET ${TARGET_NAME} APPEND_STRING PROPERTY
            LINK_FLAGS " -Wl,--no-undefined")
    endif()
endif(WIN32)

install(FILES opencl_clang.h
        DESTINATION include/cclang
        COMPONENT ${TARGET_NAME})

#
# Stripped PDB files
#
if (WIN32)
    get_target_property(RT_OUTPUT_DIRECTORY ${TARGET_NAME} RUNTIME_OUTPUT_DIRECTORY)
    file(TO_NATIVE_PATH ${RT_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/${TARGET_NAME}_stripped.pdb PDB_NAME)
    if (${MSVC_VERSION} EQUAL 1500)
        # Visual Studio 2008
        set_target_properties(${TARGET_NAME} PROPERTIES LINK_FLAGS    "${LINK_FLAGS} /PDBSTRIPPED:${PDB_NAME}")
    else (${MSVC_VERSION} EQUAL 1500)
        # Visual Studio 2010 (assumed if not Visual Studio 2008)
        # This is a fix due to a bug in CMake, Does not add the flag /DEBUG to the linker flags in Release mode.
        # The /DEBUG flag is required in order to create stripped pdbs.
        set_target_properties(${TARGET_NAME} PROPERTIES LINK_FLAGS_DEBUG    "${LINK_FLAGS_DEBUG} /PDBSTRIPPED:${PDB_NAME}")
        set_target_properties(${TARGET_NAME} PROPERTIES LINK_FLAGS_RELEASE    "${LINK_FLAGS_RELEASE} /DEBUG /PDBSTRIPPED:${PDB_NAME}")
    endif (${MSVC_VERSION} EQUAL 1500)
    if (INSTALL_PDBS)
        install(FILES ${RT_OUTPUT_DIRECTORY}/\${BUILD_TYPE}/${TARGET_NAME}.pdb DESTINATION bin)
    endif(INSTALL_PDBS)
    install(FILES ${RT_OUTPUT_DIRECTORY}/\${BUILD_TYPE}/${TARGET_NAME}_stripped.pdb DESTINATION bin)
else (WIN32)

=== debian/changelog ===
opencl-clang-19 (19.1.0-2) unstable; urgency=medium

  * Merge changes from opencl-clang-18 18.1.1-1.
  * Restrict watch file to 19.* releases.
  * Bump Standards-Version to 4.7.2.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 02 Apr 2025 22:21:53 +0200

opencl-clang-19 (19.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Fork source package as opencl-clang-19.
  * Rename binary packages: *18* => *19*.
  * Build with llvm 19.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 23 Sep 2024 15:03:27 +0200

opencl-clang-18 (18.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-17 17.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 18 Dec 2024 09:30:56 +0100

opencl-clang-18 (18.1.0-2) unstable; urgency=medium

  * Restrict watch file to 18.* releases.
  * Bump Standards-Version to 4.7.0.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 21 Sep 2024 00:45:33 +0200

opencl-clang-18 (18.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Fork source package as opencl-clang-18.
  * Rename binary packages: *17* => *18*.
  * Build with llvm 18.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 28 Mar 2024 20:36:38 +0100

opencl-clang-17 (17.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-16 16.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 18 Dec 2024 00:09:32 +0100

opencl-clang-17 (17.0.0-3) unstable; urgency=medium

  * Restrict watch file to 17.* releases.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 28 Mar 2024 18:56:19 +0100

opencl-clang-17 (17.0.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062835

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 03:02:18 +0000

opencl-clang-17 (17.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 05 Nov 2023 01:50:59 +0100

opencl-clang-17 (17.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Fork source package as opencl-clang-17.
  * Rename binary packages: *16* => *17*.
  * Build with llvm 17.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 30 Oct 2023 14:25:29 +0100

opencl-clang-16 (16.0.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 Dec 2024 12:25:46 +0100

opencl-clang-16 (16.0.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062833

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 03:00:39 +0000

opencl-clang-16 (16.0.0-3) unstable; urgency=medium

  * Restrict watch file to 16.* releases.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Sep 2023 15:28:50 +0200

opencl-clang-16 (16.0.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 15 Jun 2023 17:43:03 +0200

opencl-clang-16 (16.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Fork source package as opencl-clang-16.
  * Rename binary packages: *15* => *16*.
  * Build with llvm 16.
  * Fix building with distribution-provided llvm/clang.
  * Update .symbols control file.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 24 Apr 2023 15:46:58 +0200

opencl-clang-15 (15.0.1-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.1-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 Dec 2024 12:10:48 +0100

opencl-clang-15 (15.0.0-3) unstable; urgency=medium

  * Restrict watch file to 15.* releases.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Sep 2023 15:16:45 +0200

opencl-clang-15 (15.0.0-2) unstable; urgency=medium

  * Bump Standards-Version to 4.6.2.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Jan 2023 01:06:39 +0100

opencl-clang-15 (15.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Fork source package as opencl-clang-15.
  * Rename binary packages: *14* => *15*.
  * Build with llvm 15.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 04 Oct 2022 10:17:02 +0200

opencl-clang-14 (14.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file.
  * Bump Standards-Version to 4.7.0.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 Dec 2024 01:02:54 +0100

opencl-clang-14 (14.0.0-4) unstable; urgency=medium

  * Restrict watch file to 14.* releases.
  * Bump Standards-Version to 4.6.2.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Jan 2023 00:47:13 +0100

opencl-clang-14 (14.0.0-3) unstable; urgency=medium

  * Add .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 03 Oct 2022 22:52:25 +0200

opencl-clang-14 (14.0.0-2) unstable; urgency=medium

  * Cherry-pick commit 9bd6fe4 from upstream to fix intel-compute-runtime
    test failure.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 31 Aug 2022 08:58:18 +0200

opencl-clang-14 (14.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Fork source package as opencl-clang-14.
  * Rename binary packages: *13* => *14*.
  * Build with llvm 14.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 17 May 2022 10:18:27 +0200

intel-opencl-clang (13.0.0-5) unstable; urgency=medium

  * Add .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 02 Oct 2022 13:52:40 +0200

intel-opencl-clang (13.0.0-4) unstable; urgency=medium

  * Restrict watch file to 13.* releases.
  * Enable all hardening flags.
  * Bump Standards-Version to 4.6.1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 16 May 2022 22:41:01 +0200

intel-opencl-clang (13.0.0-3) unstable; urgency=medium

  * control: Add Conflicts/Replaces/Provides: libopencl-clang-x.y-dev.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 22 Feb 2022 01:21:52 +0100

intel-opencl-clang (13.0.0-2) unstable; urgency=medium

  * rules: Parse llvm version from Build-Depends.
  * control: Build-depend on libllvmspirvlib-13-dev.


=== debian/control ===
Source: opencl-clang-19
Section: libdevel
Priority: optional
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 cmake,
 libz-dev,
# keep the clang/llvm version in sync
 clang-19,
 libclang-19-dev,
 libclang-cpp19-dev,
 libllvmspirvlib-19-dev,
 llvm-19-dev,
# prevent accidental backports after the 64-bit time_t transition
 dpkg-dev (>= 1.22.5),
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/intel/opencl-clang
Vcs-Browser: https://salsa.debian.org/opencl-team/opencl-clang
Vcs-Git: https://salsa.debian.org/opencl-team/opencl-clang.git -b llvm19/main

Package: libopencl-clang19.1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: thin wrapper for clang
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.

Package: libopencl-clang-19-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
 libopencl-clang19.1 (= ${binary:Version}),
Conflicts:
 libopencl-clang-x.y-dev,
Breaks:
 libopencl-clang-dev (<< 13.0.0-2~),
Replaces:
 libopencl-clang-x.y-dev,
 libopencl-clang-dev (<< 13.0.0-2~),
Provides:
 libopencl-clang-x.y-dev,
Description: thin wrapper for clang -- development files
 Opencl-clang is a thin wrapper library around clang. It has an
 OpenCL-oriented API and is capable of compiling OpenCL C kernels
 to SPIR-V modules.
 .
 This package includes files needed for development.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%opencl-clang-$1.tar.gz%" \
   https://github.com/intel/opencl-clang/tags \
   (?:.*?/)?v?(19\.[\d.]*)\.tar\.gz

## opencl-clang-19 19.1.1

=== debian/changelog ===
opencl-clang-19 (19.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-18 18.1.2-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 18 Dec 2025 22:24:53 +0100

opencl-clang-18 (18.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-17 17.0.2-1.
  * Build with g++-15.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 18 Dec 2025 00:24:05 +0100

opencl-clang-18 (18.1.1-2) unstable; urgency=medium

  * Merge changes from opencl-clang-17 17.0.1-2.
  * Build with g++-14.  (Closes: #1097515)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 09 Sep 2025 11:58:35 +0200

opencl-clang-17 (17.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-16 16.0.6-1
  * Build with g++-15.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 17 Dec 2025 10:25:49 +0100

opencl-clang-17 (17.0.1-2) unstable; urgency=medium

  * Merge changes from opencl-clang-16 16.0.4-1.
  * Build with g++-14.  (Closes: #1097514)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 07 Sep 2025 22:56:11 +0200

opencl-clang-16 (16.0.6-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.5-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Dec 2025 14:46:00 +0100

opencl-clang-16 (16.0.4-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.3-1.
  * Build with g++-14.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 03 Sep 2025 11:47:15 +0200

opencl-clang-16 (16.0.3-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.2-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 09:27:05 +0200

opencl-clang-15 (15.0.5-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.5-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 16 Dec 2025 06:36:57 +0100

opencl-clang-15 (15.0.3-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.2-3.
  * Build with g++-14.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Sep 2025 23:41:19 +0200

opencl-clang-15 (15.0.2-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.2-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 12 Aug 2025 09:16:36 +0200

opencl-clang-14 (14.0.5-1) unstable; urgency=medium

  * New upstream release.
  * Drop redundant Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 14 Dec 2025 23:10:53 +0100

opencl-clang-14 (14.0.2-3) unstable; urgency=medium

  * Build with g++-14.  (Closes: #1114244)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 06 Sep 2025 08:45:50 +0200

opencl-clang-14 (14.0.2-2) unstable; urgency=medium

  * Fix building with CMake 4.  (Closes: #1113353)

 -- Andreas Beckmann <anbe@debian.org>  Tue, 02 Sep 2025 23:30:16 +0200

opencl-clang-14 (14.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.7.2.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 11 Aug 2025 14:10:32 +0200

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,6 @@
  llvm-19-dev,
 # prevent accidental backports after the 64-bit time_t transition
  dpkg-dev (>= 1.22.5),
-Rules-Requires-Root: no
 Standards-Version: 4.7.2
 Homepage: https://github.com/intel/opencl-clang
 Vcs-Browser: https://salsa.debian.org/opencl-team/opencl-clang

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS	 = hardening=+all

include /usr/share/dpkg/pkg-info.mk

LLVM_VERSION		 = $(shell sed -n -r '/^Build/,/^$$/s/.*llvm-([0-9]+)-dev.*/\1/p' debian/control)
LLVM_UPSTREAM_VERSION	 = $(shell dpkg-query -f '$${source:Upstream-Version}\n' -W llvm-$(LLVM_VERSION)-dev)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLLVMSPIRV_INCLUDED_IN_LLVM=OFF \
		-DSPIRV_TRANSLATOR_DIR=/usr/lib \
		-DCMAKE_SKIP_RPATH=true \
		-Wno-dev


ifneq (,$(wildcard .git))
upstream:
	git remote show $@ >/dev/null 2>&1 || git remote add $@ $(shell sed -rn 's/Repository: //p' debian/upstream/metadata)
	git fetch $@ --prune
endif

## opencl-clang-19 19.1.2

=== debian/changelog ===
opencl-clang-19 (19.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-18 18.1.3-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Feb 2026 22:29:17 +0100

opencl-clang-18 (18.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-17 17.0.3-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Feb 2026 00:32:47 +0100

opencl-clang-17 (17.0.3-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-16 16.0.8-1

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Feb 2026 23:56:19 +0100

opencl-clang-16 (16.0.8-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-15 15.0.6-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Feb 2026 23:24:18 +0100

opencl-clang-15 (15.0.6-1) UNRELEASED; urgency=medium

  * New upstream release.
  * Merge changes from opencl-clang-14 14.0.7-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Feb 2026 00:12:12 +0100

opencl-clang-14 (14.0.7-1) unstable; urgency=medium

  * New upstream release.
  * Fix LLVMSPIRVOpts.h/LLVMSPIRVExtensions.inc inclusion.
  * Bump Standards-Version to 4.7.3.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 08 Feb 2026 22:53:00 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: opencl-clang-19
 Section: libdevel
-Priority: optional
 Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
 Uploaders:
  Timo Aaltonen <tjaalton@debian.org>,
@@ -16,7 +15,7 @@
  llvm-19-dev,
 # prevent accidental backports after the 64-bit time_t transition
  dpkg-dev (>= 1.22.5),
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/intel/opencl-clang
 Vcs-Browser: https://salsa.debian.org/opencl-team/opencl-clang
 Vcs-Git: https://salsa.debian.org/opencl-team/opencl-clang.git -b llvm19/main

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,9 @@
 		-DCMAKE_SKIP_RPATH=true \
 		-Wno-dev
 
+execute_after_dh_clean:
+	$(RM) -r opencl-clang-??.?.?
+
 
 ifneq (,$(wildcard .git))
 upstream:
